<?php
namespace TAS\Plugin\System\TarteAuCitron\Extension;

// no direct access
defined('_JEXEC') or die;


use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\HTML\HTMLHelper;


use Joomla\CMS\Plugin\CMSPlugin;

class TarteAuCitron extends CMSPlugin
{
    
    /**
     * Application object
     *
     * @var    \Joomla\CMS\Application\CMSApplication
     * @since  4.0.0
     */
    protected $app;


    public function onAfterDispatch()
    {
        
	$document = Factory::getApplication()->getDocument();
	if (!($document instanceof \Joomla\CMS\Document\HtmlDocument))
	{
		return;
	}
	//
        // Use this plugin only in site application.
        if ($this->app->isClient('site'))
        {
		$wa = $document->getWebAssetManager();

		$wa
                ->getRegistry()
                ->addRegistryFile('media/plg_system_tarteaucitron/joomla.asset.json');

		$wa->useScript('plg_system_tarteaucitron.tarteaucitron');

		//$wa->registerAndUseScript('tas','plg_system_tarteaucitron/tarteaucitron.js', [], ['defer' => false], ['core']);

		$privacyUrl =  $this->params->get('privacyUrl','');
		$cookieName =  $this->params->get('cookieName','tarteaucitron');
		$bodyPosition =  $this->params->get('bodyPosition','bottom');
		$orientation =  $this->params->get('orientation','middle');
		$iconPosition =  $this->params->get('iconPosition','BottomRight');
		$codeJs =  $this->params->get('codeJs','');

		//echo $this->params->get('cookieName');
	   $wa->addInlineScript('
        tarteaucitron.init({
    	  "privacyUrl": "'.$privacyUrl.'", /* Privacy policy url */
          "bodyPosition": "'.$bodyPosition.'", /* or top to bring it as first element for accessibility */

    	  "hashtag": "#tarteaucitron", /* Open the panel with this hashtag */
    	  "cookieName": "'.$cookieName.'", /* Cookie name */
    
    	  "orientation": "'.$orientation.'", /* Banner position (top - bottom) */
       
          "groupServices": false, /* Group services by category */
          "showDetailsOnClick": true, /* Click to expand the description */
          "serviceDefaultState": "wait", /* Default state (true - wait - false) */
                           
    	  "showAlertSmall": false, /* Show the small banner on bottom right */
    	  "cookieslist": false, /* Show the cookie list */
                           
          "closePopup": false, /* Show a close X on the banner */

          "showIcon": true, /* Show cookie icon to manage cookies */
          //"iconSrc": "", /* Optionnal: URL or base64 encoded image */
          "iconPosition": "'.$iconPosition.'", /* BottomRight, BottomLeft, TopRight and TopLeft */

    	  "adblocker": false, /* Show a Warning if an adblocker is detected */
                           
          "DenyAllCta" : true, /* Show the deny all button */
          "AcceptAllCta" : true, /* Show the accept all button when highPrivacy on */
          "highPrivacy": true, /* HIGHLY RECOMMANDED Disable auto consent */
                           
    	  "handleBrowserDNTRequest": false, /* If Do Not Track == 1, disallow all */

    	  "removeCredit": false, /* Remove credit link */
    	  "moreInfoLink": true, /* Show more info link */

          "useExternalCss": false, /* If false, the tarteaucitron.css file will be loaded */
          "useExternalJs": false, /* If false, the tarteaucitron.js file will be loaded */

    	  //"cookieDomain": ".my-multisite-domaine.fr", /* Shared cookie for multisite */
                          
          "readmoreLink": "", /* Change the default readmore link */

          "mandatory": true, /* Show a message about mandatory cookies */
          "mandatoryCta": true, /* Show the disabled accept button when mandatory on */
    
          //"customCloserId": "" /* Optional a11y: Custom element ID used to open the panel */
        });
	' , ['position' => 'after']);


	if($codeJs!="")
		$wa->addInlineScript($codeJs , ['position' => 'after']);

        }
        
        return true;

    }

}
